public inbox for gentoo-commits@lists.gentoo.org
 help / color / mirror / Atom feed
From: "Lucio Sauer" <watermanpaint@posteo.net>
To: gentoo-commits@lists.gentoo.org
Subject: [gentoo-commits] repo/proj/guru:master commit in: app-containers/waydroid/
Date: Tue,  6 Aug 2024 14:59:40 +0000 (UTC)	[thread overview]
Message-ID: <1722954120.c267d4087ebd2ed3c4b2986d5ae64e58abeceeab.watermanpaint@gentoo> (raw)

commit:     c267d4087ebd2ed3c4b2986d5ae64e58abeceeab
Author:     Denis Reva <denis7774 <AT> gmail <DOT> com>
AuthorDate: Tue Aug  6 14:22:00 2024 +0000
Commit:     Lucio Sauer <watermanpaint <AT> posteo <DOT> net>
CommitDate: Tue Aug  6 14:22:00 2024 +0000
URL:        https://gitweb.gentoo.org/repo/proj/guru.git/commit/?id=c267d408

app-containers/waydroid: Added more kernel checks

* CONFIG_NETFILTER_XT_TARGET_MASQUERADE
* CONFIG_NETFILTER_XT_NAT

Closes: https://bugs.gentoo.org/937106
Signed-off-by: Denis Reva <denis7774 <AT> gmail.com>

 app-containers/waydroid/waydroid-1.4.2-r2.ebuild | 96 ++++++++++++++++++++++++
 1 file changed, 96 insertions(+)

diff --git a/app-containers/waydroid/waydroid-1.4.2-r2.ebuild b/app-containers/waydroid/waydroid-1.4.2-r2.ebuild
new file mode 100644
index 000000000..89c34aaa8
--- /dev/null
+++ b/app-containers/waydroid/waydroid-1.4.2-r2.ebuild
@@ -0,0 +1,96 @@
+# Copyright 2022-2024 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+PYTHON_COMPAT=( python3_{10..12} )
+inherit linux-info xdg python-single-r1
+
+DESCRIPTION="Container-based approach to boot a full Android system on Linux systems"
+HOMEPAGE="https://waydro.id"
+SRC_URI="https://github.com/${PN}/${PN}/archive/${PV}.tar.gz -> ${P}.tar.gz"
+
+LICENSE="GPL-3"
+SLOT="0"
+KEYWORDS="~amd64 ~arm ~arm64 ~x86"
+REQUIRED_USE="${PYTHON_REQUIRED_USE}"
+IUSE="apparmor +clipboard systemd"
+
+DEPEND="|| ( virtual/linux-sources virtual/dist-kernel )"
+RDEPEND="
+	systemd? ( sys-apps/systemd )
+	app-containers/lxc[systemd?,apparmor?,seccomp]
+	$(python_gen_cond_dep '
+		clipboard? ( >=dev-python/pyclip-0.7.0[wayland,${PYTHON_USEDEP}] )
+		dev-python/pygobject[${PYTHON_USEDEP}]
+		>=dev-python/gbinder-1.1.1[${PYTHON_USEDEP}]
+		dev-python/dbus-python[${PYTHON_USEDEP}]
+	')
+	net-firewall/nftables
+	net-dns/dnsmasq
+	>=dev-libs/libglibutil-1.0.67
+	>=dev-libs/gbinder-1.1.21
+	${PYTHON_DEPS}
+"
+
+CONFIG_CHECK="
+	~ANDROID_BINDER_IPC
+	~ANDROID_BINDERFS
+	~MEMFD_CREATE
+	~NETFILTER_XT_TARGET_MASQUERADE
+	~NETFILTER_XT_NAT
+"
+ERROR_ANDROID_BINDERFS="CONFIG_ANDROID_BINDERFS: need for creating Android-specific binder IPC channels"
+ERROR_ANDROID_BINDER_IPC="CONFIG_ANDROID_BINDER_IPC: need for creating Android-specific binder IPC channels"
+ERROR_MEMFD_CREATE="CONFIG_MEMFD_CREATE: it completely replaced deprecated ISHMEM drivers,
+	therefore it's vital for android-specific memory management"
+ERROR_NETFILTER_XT_NAT="CONFIG_NETFILTER_XT_NAT: see bug #937106"
+ERROR_NETFILTER_XT_TARGET_MASQUERADE="CONFIG_NETFILTER_XT_TARGET_MASQUERADE: see bug #937106"
+
+
+pkg_setup() {
+	linux-info_pkg_setup
+	python-single-r1_pkg_setup
+}
+
+src_prepare() {
+	if ! use apparmor; then
+		# https://github.com/waydroid/waydroid/issues/652
+		sed -e '/^lxc\.apparmor\.profile =/d' \
+			-i data/configs/config_3 || die
+	fi
+	default
+}
+
+src_install() {
+	python_fix_shebang waydroid.py
+	emake install DESTDIR="${D}" USE_NFTABLES=1 USE_SYSTEMD=$(usex systemd 1 0)
+	if ! use systemd; then
+		elog "Installing waydroid OpenRC daemon"
+		doinitd "${FILESDIR}"/waydroid
+	fi
+}
+
+pkg_postinst() {
+	xdg_pkg_postinst
+
+	elog "After package installation run either 'emerge --config app-containers/waydroid'"
+	elog "or 'waydroid init' from root shell to install android container runtime"
+	elog "To run waydroid, 1. Start container: 'rc-service waydroid start'"
+	elog "2. start wayland channel (from user shell) 'waydroid session start'"
+	elog "Contact https://docs.waydro.id/usage/install-on-desktops for how-to guides"
+	elog "(does not cover Gentoo-specific things sadly)"
+	elog
+
+	ewarn "Make sure you have NFTABLES up and running in your kernel. See"
+	ewarn "https://wiki.gentoo.org/wiki/Nftables for how-to details"
+	ewarn
+
+	if use apparmor; then
+		ewarn "Apparmor support has not been tested by package maintainer yet"
+	fi
+}
+
+pkg_config() {
+	"${EROOT}"/usr/bin/waydroid init
+}


             reply	other threads:[~2024-08-06 14:59 UTC|newest]

Thread overview: 20+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2024-08-06 14:59 Lucio Sauer [this message]
  -- strict thread matches above, loose matches on Subject: below --
2025-01-11 12:50 [gentoo-commits] repo/proj/guru:master commit in: app-containers/waydroid/ David Roman
2024-11-16 20:24 Julien Roy
2024-05-15 17:00 Julien Roy
2024-03-22 19:17 Julien Roy
2024-03-21 23:06 Julien Roy
2024-03-21 23:06 Julien Roy
2024-03-21 23:06 Julien Roy
2024-03-21 23:06 Julien Roy
2024-03-21 23:06 Julien Roy
2024-03-21 23:06 Julien Roy
2024-02-19 22:00 Julien Roy
2024-02-19 22:00 Julien Roy
2024-02-19 21:47 [gentoo-commits] repo/proj/guru:dev " Julien Roy
2024-02-19 22:00 ` [gentoo-commits] repo/proj/guru:master " Julien Roy
2024-02-18 19:53 [gentoo-commits] repo/proj/guru:dev " Julien Roy
2024-02-18 20:37 ` [gentoo-commits] repo/proj/guru:master " Julien Roy
2024-02-18 19:53 [gentoo-commits] repo/proj/guru:dev " Julien Roy
2024-02-18 20:37 ` [gentoo-commits] repo/proj/guru:master " Julien Roy
2023-10-30 11:30 [gentoo-commits] repo/proj/guru:dev " David Roman
2023-10-30 11:32 ` [gentoo-commits] repo/proj/guru:master " David Roman
2022-12-29 11:33 Florian Schmaus
2022-12-29 11:33 [gentoo-commits] repo/proj/guru:dev " Florian Schmaus
2022-12-29 11:33 ` [gentoo-commits] repo/proj/guru:master " Florian Schmaus
2022-12-29 11:28 [gentoo-commits] repo/proj/guru:dev " Florian Schmaus
2022-12-29 11:33 ` [gentoo-commits] repo/proj/guru:master " Florian Schmaus

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1722954120.c267d4087ebd2ed3c4b2986d5ae64e58abeceeab.watermanpaint@gentoo \
    --to=watermanpaint@posteo.net \
    --cc=gentoo-commits@lists.gentoo.org \
    --cc=gentoo-dev@lists.gentoo.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox